
decals = {}

function createNewDecal(img,x,y,angle,time)
  table.insert(decals,{img=img,x=x,y=y,timer = 0,angle=angle,time=time})
end

function clearDecals(dt)
  for _,v in ipairs(decals) do
    v.timer = v.timer + dt
    if v.timer >= v.time then
      table.remove(decals,_)
      v.timer = 0
    end
  end
end

function drawDecals()
  for _,v in ipairs(decals) do
    love.graphics.draw(v.img,v.x,v.y,v.angle)
  end
end

function getMagnitude(x1,x2,y2,y1)
  local d = math.sqrt((x2-x1)^2+(y2-y1)^2)
  return d
end

function CheckCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)
  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end