
goal = 2000
fc = 1
tc =0
tspeed = 0
gspeed = 0.1
bossbattle = false
bossDetermined = false
currentboss = ""

local lx = screenwidth/2
local ly = 0
local lx2 = screenwidth/2
local ly2 = 0
local lx3 = screenwidth/2
local ly3 = 0
lyw = screenwidth/2
lyh = screenheight/4
lx4 = screenwidth/2 - lyw/2
ly4 = 0 - lyh
booplayed = false
yayplayed = false
dunplayed = false
quitclicked = false

function quitOpt(dt)
  if quitclicked then
    if ly4 >= screenheight/2 - lyh then
      ly4 = screenheight/2 - lyh
    else
      ly4 = ly4 + 7 + dt
    end
  elseif not quitclicked then
    if ly4 >= 0 - lyh then
      ly4 = ly4 - 7 - dt
    else
      ly4 = 0 - lyh
    end
  end
end

function drawQOpt()
  love.graphics.setColor(84/255,84/255,84/255,220/255)
  love.graphics.rectangle("fill",lx4,ly4,lyw,lyh)
  love.graphics.setColor(255,255,255,255)
  love.graphics.setFont(large)
  love.graphics.print("Quit?",lx4+string.len("quit")*25,ly4)
  love.graphics.setFont(small)
  love.graphics.print("Your progess will not be saved...",lx4+string.len("Your progess will not be saved..."),ly4*1.8)
  love.graphics.setColor(255,255,255,255)
end

local dTimer = 0
function notifyDun(dt)
  if bossbattle then
    dTimer = dTimer + dt
    if not dunplayed and not bossDetermined then
        dun:play()
        dunplayed = true
      end
    if ly3 >= screenheight/2 then
      ly3 = screenheight/2
    else
      ly3 = ly3 + 6 + dt
    end
    if dTimer >= 4 then
        dunplayed = true
        dTimer = 0
        ly3 = 0
        bossDetermined = true
    end
  end
end

local lTimer = 0
function lose(dt)
  Animations[1]:pause()
  lTimer = lTimer + dt
  if not booplayed then
    boss.music:stop()
    music:setVolume(0.7)
    music:setPitch(0.5)
    boo:play()
    booplayed = true
  end
  if ly >= screenheight/2 then
    ly = screenheight/2
  else
    ly = ly + 6 + dt
  end
  if lTimer >= 6 then
    music:stop()
    gamestate = "lose"
    ly = 0
    lTimer = 0
  end
end

function player_die(dt)
  if player.health <= 0 then
    player.dead = true
    lose(dt)
  end
end

function game_status(dt)
  if tc >= 100 and tc < 200 and not bossbattle then
    gspeed = 0.11
    tspeed = 0.3
    fc = 6
  end
  if tc >= 200 and tc < 300 and not bossbattle then
    gspeed = 0.13
    tspeed = 0.5
    fc = 8
  end
  if tc >= 300 and tc < 400 and not bossbattle then
    gspeed = 0.15
    tspeed = 0.7
    fc = 10
  end
  if tc >= 400 and tc < 500 and not bossbattle then
    gspeed = 0.17
    tspeed = 0.9
    fc = 12
  end
  if tc >= 500 and tc < 600 and not bossbattle then
    gspeed = 0.19
    tspeed = 0.11
    fc = 14
  end
  if tc >= 600 and tc < 700 and not bossbattle then
    gspeed = 0.21
    tspeed = 0.13
    fc = 16
  end
  if tc >= 700 and tc < 800 and not bossbattle then
    gspeed = 0.23
    tspeed = 0.15
    fc = 18
  end
  if tc >= 800 and tc < 900 and not bossbattle then
    gspeed = 0.25
    tspeed = 0.17
    fc = 20
  end
  if tc >= 900 and tc < goal and not bossbattle then
    gspeed = 0.27
    tspeed = 0.19
    fc = 22
  end
  if tc >= goal and not bossbattle then
    goalreached(dt)
    gspeed = 0.1
    tspeed = 0
    fc = 1
  end
end

function determineBoss(dt)
  if bossbattle and not bossDetermined then
    if currentboss == "narwhal" then
      boss.img = boss1
      boss.face = "left"
      boss.width = boss.img:getWidth()
      boss.height = boss.img:getHeight()
      boss.x = screenwidth/2 - boss.width/2
      boss.y = screenheight/2 - boss.height/2
      boss.xvel = 0
      boss.yvel = 0
      boss.friction = 10
      boss.health = 500
      player.health = 100
      boss.speed = 600
      boss.eat = bossnom1
      boss.hurt = bosshurt1
      boss.intro = bossintro1
      boss.die = bossdie1
      boss.win = bosswin1
      boss.music = bossmusic1
      boss.damage = 4
      boss.shootspeed = 3
      notifyDun(dt)
      boss.bombdrop = 10
    end
    if currentboss == "donut" then
      boss.img = boss2
      boss.face = "left"
      boss.width = boss.img:getWidth()
      boss.height = boss.img:getHeight()
      boss.x = screenwidth/2 - boss.width/2
      boss.y = screenheight/2 - boss.height/2
      boss.xvel = 0
      boss.yvel = 0
      boss.friction = 5
      boss.health = 700
      player.health = 100
      boss.speed = 700
      boss.eat = bossnom2
      boss.hurt = bosshurt2
      boss.intro = bossintro2
      boss.die = bossdie2
      boss.win = bosswin2
      boss.music = bossmusic2
      boss.damage = 7
      boss.shootspeed = 2
      boss.bombdrop = 7
      notifyDun(dt)
    end
  end
end

local gTimer = 0
function goalreached(dt)
  if tc >= goal then
    if not yayplayed then
      music:stop()
      yay:play()
      player.health = 100
      yayplayed = true
    end
    gTimer = gTimer + dt
    if ly2 >= screenheight/2 then
      ly2 = screenheight/2
    else
      ly2 = ly2 + 6 + dt
    end
    if gTimer >= 4 and not bossbattle then
      ly2 = 0
      bossbattle = true
      gTimer = 0
      tc = 0
    end
  end
end

function game_load()
  phealth = player.health
  createNewProgressBar(screenwidth/2-70/2,screenheight/20-20,70,20,"health","Health",small,"game",127,0,0,phealth,100,0)
  createNewProgressBar(screenwidth/1.5-70/2,screenheight/20-20,70,20,"tacos","Goal",small,"game",51,156,12,tc,goal/10,0)
  createNewImageButton(gear,0,0,"leave","",nil,small,medium,"game",nom,nil,255,255,255,200,200,200,69.65)
  createNewButton(screenwidth/2,screenheight/2,100,50,"yes","Yes","YES!",small,medium,"game",nom,nil,200,200,200,100,100,100)
end

function game_draw()
	if not bossbattle then
    shader_draw(effect)
	elseif bossbattle and currentboss == "narwhal"then
    camera:set()
    light:DrawGif(-screenwidth*2,-screenheight*2,0,6,6)
    camera:unset()
  elseif bossbattle and currentboss == "donut" then
    camera:set()
    tunnel:DrawGif(-screenwidth*2,-screenheight*2,0,7,6)
    camera:unset()
	end
  current2:setFilter("nearest","nearest")
  love.graphics.draw(current2,current3,0,screenheight-current2:getHeight()- current1:getHeight(),0,1,1)
  current1:setFilter("nearest","nearest")
  love.graphics.draw(current1,0,screenheight-grass:getHeight(),0,1.5,1)
  drawClouds()
  tacoDraw()
  drawDecals()
  player_draw()
  if bossDetermined and dunplayed then
    boss_Draw()
  end
  if not player.dead then
    boss.face = "right"
  end
  if player.dead then
    love.graphics.setFont(large)
    love.graphics.setColor(127/255,0,0)
    love.graphics.print("You have died!",lx-string.len("You have died!")*15,ly)
    love.graphics.setColor(255,255,255,255)
  end
  if tc >= goal and not bossbattle then
    love.graphics.setFont(large)
    love.graphics.setColor(51/255,156/255,121/255)
    love.graphics.print("Goal Reached!",lx2-string.len("Goal Reached!")*15,ly2)
    love.graphics.setFont(medium)
    love.graphics.setColor(math.random(1,255)/255,math.random(1,255)/255,math.random(1,255)/255)
    love.graphics.print("+100 Points",lx2-string.len("+100 Points")*5,ly2+50)
    love.graphics.setColor(255,255,255,255)
  end
  if bossbattle and not bossDetermined then
    love.graphics.setFont(large)
    love.graphics.setColor(127/255,0,0)
    love.graphics.print("Boss Battle!",lx3-string.len("Boss Battle!")*15,ly3)
    love.graphics.setColor(255,255,255,255)
  end
  drawQOpt()
end

function game_update(dt)
  camera:rotate(dt)
	light:UpdateGif(dt,dt)
  tunnel:UpdateGif(dt,dt)
  phealth = player.health
  if not player.dead and not quitclicked then
    if(bossbattle) then
      if(boss.introsaid) then
        tacoRain(dt)
      end
    else
      tacoRain(dt)
    end
    cloudSpawner(dt)
    player_controls(dt)
    player_physics(dt)
    if bossDetermined and dunplayed then
      bossStatus(dt)
    end
  end
  clearDecals(dt)
  determineBoss(dt)
  player_die(dt)
  game_status(dt)
  quitOpt(dt)
end

function game_key(key)
  player_jump(key)
end
