
Hat = {}

hats = -1

local files =  love.filesystem.getDirectoryItems(idir.."hats")

currentclip = 0

selected = 0

bx = screenwidth/2-180/2
by = screenheight/6
bxw = 180
byh = 50

function calculateScale()
  for i,v in ipairs(files) do
    hats = hats + 1
  end
end

function createNewHat(id,text,price,img,purchased)
  table.insert(Hat,{x=x,y=y,width=width,height=height,id=id,price=price,text=text,img=img,purchased=purchased})
end

function loadHats()
  trollprice = math.random(15000,20000)
  earth = love.graphics.newImage(idir.."hats/almostearth.png")
  antene = love.graphics.newImage(idir.."hats/antene.png")
  bloon = love.graphics.newImage(idir.."hats/balloon.png")
  dcrown = love.graphics.newImage(idir.."hats/darkcrown.png")
  ducky = love.graphics.newImage(idir.."hats/ducky.png")
  stack = love.graphics.newImage(idir.."hats/headstack.png")
  stack2 = love.graphics.newImage(idir.."headstack2.png")
  bulb = love.graphics.newImage(idir.."hats/lightbulb.png")
  rcrown = love.graphics.newImage(idir.."hats/rainbowcrown.png")
  tophat = love.graphics.newImage(idir.."hats/tophat.png")
  troll = love.graphics.newImage(idir.."hats/trollfaic.png")
  createNewHat("hat1","Almost Earth",850,earth,g.hat1)
  createNewHat("hat2","Antenna",250,antene,g.hat2)
  createNewHat("hat3","Balloon",9500,bloon,g.hat3)
  createNewHat("hat4","Dark Crown",11000,dcrown,g.hat4)
  createNewHat("hat5","Ducky",800,ducky,g.hat5)
  createNewHat("hat6","Head Stack",5000,stack,g.hat6)
  createNewHat("hat7","Light Bulb",10000,bulb,g.hat7)
  createNewHat("hat8","Rainbow Crown",12000,rcrown,g.hat8)
  createNewHat("hat9","Top Hat",450,tophat,g.hat9)
  createNewHat("hat10","Troll",trollprice,troll,g.hat10)
end

function posHats()
  for _,v in ipairs(Hat) do
    if v.id == "hat1" then
      love.graphics.setColor(192,192,192,100)
      love.graphics.rectangle("fill",screenwidth/2.9,hats*40.5-currentclip,screenwidth/2,50)
      love.graphics.setColor(255,255,255,255)
      v.x = screenwidth/2.9
      v.y = hats * 40.5 - currentclip
      love.graphics.draw(v.img,v.x,v.y+ v.img:getHeight()/2)
      love.graphics.setFont(small)
      love.graphics.setColor(0,0,0,255)
      love.graphics.print(v.text,v.x+28,v.y+17)
      love.graphics.print("Price: "..v.price,v.x+150,v.y+17)
      if not v.purchased then
         love.graphics.print("Not Owned",v.x+240,v.y+17)
      else
        love.graphics.print("Owned",v.x+240,v.y+17)
      end
    end
    if v.id == "hat2" then
      love.graphics.setColor(192,192,192,100)
      love.graphics.rectangle("fill",screenwidth/2.9,hats*46.5-currentclip,screenwidth/2,50)
      love.graphics.setColor(255,255,255,255)
      v.x = screenwidth/2.9
      v.y = hats * 46.5 - currentclip
      love.graphics.draw(v.img,v.x,v.y+ v.img:getHeight()/2)
      love.graphics.setFont(small)
      love.graphics.setColor(0,0,0,255)
      love.graphics.print(v.text,v.x+48,v.y+17)
      love.graphics.print("Price: "..v.price,v.x+150,v.y+17)
      if not v.purchased then
         love.graphics.print("Not Owned",v.x+240,v.y+17)
      else
        love.graphics.print("Owned",v.x+240,v.y+17)
      end
    end
    if v.id == "hat3" then
      love.graphics.setColor(192,192,192,100)
      love.graphics.rectangle("fill",screenwidth/2.9,hats*52.5-currentclip,screenwidth/2,50)
      love.graphics.setColor(255,255,255,255)
      v.x = screenwidth/2.9
      v.y = hats * 52.5 - currentclip
      love.graphics.draw(v.img,v.x,v.y+ v.img:getHeight()/2)
      love.graphics.setFont(small)
      love.graphics.setColor(0,0,0,255)
      love.graphics.print(v.text,v.x+28,v.y+17)
      love.graphics.print("Price: "..v.price,v.x+150,v.y+17)
      if not v.purchased then
         love.graphics.print("Not Owned",v.x+240,v.y+17)
      else
        love.graphics.print("Owned",v.x+240,v.y+17)
      end
    end
    if v.id == "hat4" then
      love.graphics.setColor(192,192,192,100)
      love.graphics.rectangle("fill",screenwidth/2.9,hats*58.5-currentclip,screenwidth/2,50)
      love.graphics.setColor(255,255,255,255)
      v.x = screenwidth/2.9
      v.y = hats * 58.5 - currentclip
      love.graphics.draw(v.img,v.x,v.y+ v.img:getHeight()/2)
      love.graphics.setFont(small)
      love.graphics.setColor(0,0,0,255)
      love.graphics.print(v.text,v.x+28,v.y+17)
      love.graphics.print("Price: "..v.price,v.x+150,v.y+17)
      if not v.purchased then
         love.graphics.print("Not Owned",v.x+240,v.y+17)
      else
        love.graphics.print("Owned",v.x+240,v.y+17)
      end
    end
     if v.id == "hat5" then
      love.graphics.setColor(192,192,192,100)
      love.graphics.rectangle("fill",screenwidth/2.9,hats*64.5-currentclip,screenwidth/2,50)
      love.graphics.setColor(255,255,255,255)
      v.x = screenwidth/2.9
      v.y = hats * 64.5 - currentclip
      love.graphics.draw(v.img,v.x,v.y+ v.img:getHeight()/2)
      love.graphics.setFont(small)
      love.graphics.setColor(0,0,0,255)
      love.graphics.print(v.text,v.x+28,v.y+17)
      love.graphics.print("Price: "..v.price,v.x+150,v.y+17)
      if not v.purchased then
         love.graphics.print("Not Owned",v.x+240,v.y+17)
      else
        love.graphics.print("Owned",v.x+240,v.y+17)
      end
    end
     if v.id == "hat6" then
      love.graphics.setColor(192,192,192,100)
      love.graphics.rectangle("fill",screenwidth/2.9,hats*70.5-currentclip,screenwidth/2,50)
      love.graphics.setColor(255,255,255,255)
      v.x = screenwidth/2.9
      v.y = hats * 70.5 - currentclip
      love.graphics.draw(v.img,v.x,v.y+ v.img:getHeight()/2)
      love.graphics.setFont(small)
      love.graphics.setColor(0,0,0,255)
      love.graphics.print(v.text,v.x+28,v.y+17)
      love.graphics.print("Price: "..v.price,v.x+150,v.y+17)
      if not v.purchased then
         love.graphics.print("Not Owned",v.x+240,v.y+17)
      else
        love.graphics.print("Owned",v.x+240,v.y+17)
      end
    end
     if v.id == "hat7" then
      love.graphics.setColor(192,192,192,100)
      love.graphics.rectangle("fill",screenwidth/2.9,hats*76.5-currentclip,screenwidth/2,50)
      love.graphics.setColor(255,255,255,255)
      v.x = screenwidth/2.9
      v.y = hats * 76.5 - currentclip
      love.graphics.draw(v.img,v.x,v.y+ v.img:getHeight()/2)
      love.graphics.setFont(small)
      love.graphics.setColor(0,0,0,255)
      love.graphics.print(v.text,v.x+28,v.y+17)
      love.graphics.print("Price: "..v.price,v.x+150,v.y+17)
      if not v.purchased then
         love.graphics.print("Not Owned",v.x+240,v.y+17)
      else
        love.graphics.print("Owned",v.x+240,v.y+17)
      end
    end
     if v.id == "hat8" then
      love.graphics.setColor(192,192,192,100)
      love.graphics.rectangle("fill",screenwidth/2.9,hats*82.5-currentclip,screenwidth/2,50)
      love.graphics.setColor(255,255,255,255)
      v.x = screenwidth/2.9
      v.y = hats * 82.5 - currentclip
      love.graphics.draw(v.img,v.x,v.y+ v.img:getHeight()/2)
      love.graphics.setFont(small)
      love.graphics.setColor(0,0,0,255)
      love.graphics.print(v.text,v.x+28,v.y+17)
      love.graphics.print("Price: "..v.price,v.x+150,v.y+17)
      if not v.purchased then
         love.graphics.print("Not Owned",v.x+240,v.y+17)
      else
        love.graphics.print("Owned",v.x+240,v.y+17)
      end
    end
     if v.id == "hat9" then
      love.graphics.setColor(192,192,192,100)
      love.graphics.rectangle("fill",screenwidth/2.9,hats*88.5-currentclip,screenwidth/2,50)
      love.graphics.setColor(255,255,255,255)
      v.x = screenwidth/2.9
      v.y = hats * 88.5 - currentclip
      love.graphics.draw(v.img,v.x,v.y+ v.img:getHeight()/2)
      love.graphics.setFont(small)
      love.graphics.setColor(0,0,0,255)
      love.graphics.print(v.text,v.x+28,v.y+17)
      love.graphics.print("Price: "..v.price,v.x+150,v.y+17)
      if not v.purchased then
         love.graphics.print("Not Owned",v.x+240,v.y+17)
      else
        love.graphics.print("Owned",v.x+240,v.y+17)
      end
    end
     if v.id == "hat10" then
      love.graphics.setColor(192,192,192,100)
      love.graphics.rectangle("fill",screenwidth/2.9,hats*94.5-currentclip,screenwidth/2,50)
      love.graphics.setColor(255,255,255,255)
      v.x = screenwidth/2.9
      v.y = hats * 94.5 - currentclip
      love.graphics.draw(v.img,v.x,v.y+ v.img:getHeight()/2)
      love.graphics.setFont(small)
      love.graphics.setColor(0,0,0,255)
      love.graphics.print(v.text,v.x+28,v.y+17)
      love.graphics.print("Price: "..v.price,v.x+150,v.y+17)
      if not v.purchased then
         love.graphics.print("Not Owned",v.x+240,v.y+17)
      else
        love.graphics.print("Owned",v.x+240,v.y+17)
      end
    end
  end
end

function selectHats(x,y)
  for _,v in ipairs(Hat) do
    v.x = screenwidth/2.9
    if x > v.x and
      x < v.x + v.img:getWidth()and
      y > v.y and
      y < v.y + v.img:getHeight()then
      if v.id == "hat1" and not v.purchased then
        selected = v.id
        player.mhat = earth
      end
       if v.id == "hat2" and not v.purchased then
        selected = v.id
        player.mhat = antene
      end
       if v.id == "hat3" and not v.purchased then
        selected = v.id
        player.mhat = bloon
      end
       if v.id == "hat4" and not v.purchased then
        selected = v.id
        player.mhat = dcrown
      end
      if v.id == "hat5" and not v.purchased then
        selected = v.id
        player.mhat = ducky
      end
      if v.id == "hat6" and not v.purchased then
        selected = v.id
        player.mhat = stack
      end
      if v.id == "hat7" and not v.purchased then
        selected = v.id
        player.mhat = bulb
      end
      if v.id == "hat8" and not v.purchased then
        selected = v.id
        player.mhat = rcrown
      end
      if v.id == "hat9" and not v.purchased then
        selected = v.id
        player.mhat = tophat
      end
      if v.id == "hat10" and not v.purchased then
        selected = v.id
        player.mhat = troll
      end
    end
  end
end

function wearHat(x,y)
  for _,v in ipairs(Hat) do
    v.x = screenwidth/2.9
    if x > v.x and
      x < v.x + v.img:getWidth() and
      y > v.y and
      y < v.y + v.img:getHeight() then
      selected = v.id
      if v.id == "hat1" and v.purchased then
        player.hat = v.id
        player.mhat = earth
        player.hatv = earth
      end
       if v.id == "hat2" and v.purchased then
        player.hat = v.id
        player.mhat = antene
        player.hatv = antene
      end
       if v.id == "hat3" and v.purchased then
        player.hat = v.id
        player.mhat = bloon
        player.hatv = bloon
      end
       if v.id == "hat4" and v.purchased then
        player.hat = v.id
        player.mhat = dcrown
        player.hatv = dcrown
      end
      if v.id == "hat5" and v.purchased then
        player.hat = v.id
        player.mhat = ducky
        player.hatv = ducky
      end
      if v.id == "hat6" and v.purchased then
        player.hat = v.id
        player.mhat = stack
        player.hatv = stack
      end
      if v.id == "hat7" and v.purchased then
        player.hat = v.id
        player.mhat = bulb
        player.hatv = bulb
      end
      if v.id == "hat8" and v.purchased then
        player.hat = v.id
        player.mhat = rcrown
        player.hatv = rcrown
      end
      if v.id == "hat9" and v.purchased then
        player.hat = v.id
        player.mhat = tophat
        player.hatv = tophat
      end
      if v.id == "hat10" and v.purchased then
        player.hat = v.id
        player.mhat = troll
        player.hatv = troll
      end
    end
  end
end

function purchaseHat(x,y)
  for _,v in ipairs(Hat) do
    if x > bx and
      x < bx + bxw and
      y > by and
      y < by + byh then
      if v.id == "hat1" and selected  == "hat1" and not v.purchased and g.points >= v.price then
        g.points = g.points - v.price
        player.hat = v.id
        g.hat1 = true
        v.purchased = true
      end
      if v.id == "hat2" and selected  == "hat2" and not v.purchased and g.points >= v.price then
        g.points = g.points - v.price
        player.hat = v.id
        g.hat2 = true
        v.purchased = true
      end
      if v.id == "hat3" and selected  == "hat3" and not v.purchased and g.points >= v.price then
        g.points = g.points - v.price
        player.hat = v.id
        g.hat3 = true
        v.purchased = true
      end
      if v.id == "hat4" and selected  == "hat4" and not v.purchased and g.points >= v.price then
        g.points = g.points - v.price
        player.hat = v.id
        g.hat4 = true
        v.purchased = true
      end
      if v.id == "hat5" and selected  == "hat5" and not v.purchased and g.points >= v.price then
        g.points = g.points - v.price
        player.hat = v.id
        g.hat5 = true
        v.purchased = true
      end
      if v.id == "hat6" and selected  == "hat6" and not v.purchased and g.points >= v.price then
        g.points = g.points - v.price
        player.hat = v.id
        g.hat6 = true
        v.purchased = true
      end
      if v.id == "hat7" and selected  == "hat7" and not v.purchased and g.points >= v.price then
        g.points = g.points - v.price
        player.hat = v.id
        g.hat7 = true
        v.purchased = true
      end
      if v.id == "hat8" and selected == "hat8" and not v.purchased and g.points >= v.price then
        g.points = g.points - v.price
        player.hat = v.id
        g.hat8 = true
        v.purchased = true
      end
      if v.id == "hat9" and selected == "hat9" and not v.purchased and g.points >= v.price then
        g.points = g.points - v.price
        player.hat = v.id
        g.hat9 = true
        v.purchased = true
      end
      if v.id == "hat10" and selected == "hat10" and not v.purchased and g.points >= v.price then
        g.points = g.points - v.price
        player.hat = v.id
        g.hat10 = true
        v.purchased = true
      end
      end
  end
end

function setPlayerHat()
  if player.hat ~= 0 and player.hat == "hat1" or player.hat == "hat2" or player.hat == "hat3" or player.hat == "hat4" or player.hat == "hat5" or player.hat == "hat6"  or player.hat == "hat7" or player.hat == "hat8" or player.hat == "hat9" or player.hat == "hat10" then
    if player.hat == "hat1" then
      player.hatv = earth
      love.graphics.draw(earth,player.x-player.width/2,player.y-player.height/2-earth:getHeight())
      player.speed = 240
      player.grav = 1.5
      player.damage = 3
      player.multiplier = 0 
    end
    if player.hat == "hat2" then
      player.hatv = antene
      love.graphics.draw(antene,player.x-player.width/2,player.y-player.height/2-antene:getHeight())
      player.speed = 200
      player.grav = 1.25
      player.damage = 3
      player.multiplier = 0
    end
    if player.hat == "hat3" then
      player.hatv = bloon
      love.graphics.draw(bloon,player.x-player.width/2,player.y-player.height/2-bloon:getHeight())
      player.speed = 200 
      player.grav = 0.6
      player.damage = 3
      player.multiplier = 0 
    end
    if player.hat == "hat4" then
      player.hatv = dcrown
      love.graphics.draw(dcrown,player.x-player.width/2,player.y-player.height/2-dcrown:getHeight())
      player.speed = 200
      player.grav = 1.5
      player.damage = 5
      player.multiplier = 0
    end
    if player.hat == "hat5" then
      player.hatv = ducky
      love.graphics.draw(ducky,player.x-player.width/2,player.y-player.height/2-ducky:getHeight())
      player.speed = 200
      player.grav = 1.5
      player.damage = 3
      player.multiplier = 0.5
    end
    if player.hat == "hat6" then
      player.hatv = stack
      love.graphics.draw(stack,player.x-player.width/2,player.y-player.height/2-stack:getHeight())
      player.speed = 200
      player.grav = 1
      player.damage = 3
      player.multiplier = 0 
    end
    if player.hat == "hat7" then
      player.hatv = bulb
      love.graphics.draw(bulb,player.x-player.width/2,player.y-player.height/2-bulb:getHeight())
      player.speed = 500
      player.grav = 1.5
      player.damage = 3
      player.multiplier = 0 
    end
    if player.hat == "hat8" then
      player.hatv = rcrown
      love.graphics.draw(rcrown,player.x-player.width/2,player.y-player.height/2-rcrown:getHeight())
      player.speed = 200
      player.grav = 1.5
      player.damage = 3
      player.multiplier = 2
    end
    if player.hat == "hat9" then
      player.hatv = tophat
      love.graphics.draw(tophat,player.x-player.width/2,player.y-player.height/2-tophat:getHeight())
      player.speed = 210
      player.grav = 1.5
      player.damage = 3
      player.multiplier = 0 
    end
    if player.hat == "hat10" then
      player.hatv = troll
      love.graphics.draw(troll,player.x-player.width/1.5,player.y-player.height/6-troll:getHeight(),0,1.5,1.5)
      player.speed = 260
      player.grav = 1.1
      player.damage = 4
      player.multiplier = 0.3 
    end
  elseif player.hat == 0 then
    player.speed = 200
    player.grav = 1.5
    player.damage = 3
    player.multiplier = 0
  elseif player.hat ~= "hat1" and player.hat ~= "hat2" and player.hat ~= "hat3" and player.hat ~= "hat4" and player.hat ~= "hat5" and player.hat ~= "hat6" and player.hat ~= "hat7" and player.hat ~= "hat8" and player.hat ~= "hat9" and player.hat ~= "hat10" and player.hat ~= 0 then
      love.graphics.draw(missing,player.x-player.width/2,player.y-player.height/2-missing:getHeight())
      player.speed = 200
      player.grav = 1.5
      player.damage = 3
      player.multiplier = 0
  end
end
