
local lx = screenwidth/2
local ly = 0
paused = false

function inf_load()
  createNewProgressBar(screenwidth/2-70/2,screenheight/20-20,70,20,"health","Health",small,"game2",127,0,0,phealth,100,0)
  createNewImageButton(gear,0,0,"ileave","",nil,small,medium,"game2",nom,nil,255,255,255,200,200,200,69.65)
  createNewButton(screenwidth/2,screenheight/2,100,50,"yes","Yes","YES!",small,medium,"game2",nom,nil,200,200,200,100,100,100)
end

local function iquitOpt(dt)
  if paused then
    if ly4 >= screenheight/2 - lyh then
      ly4 = screenheight/2 - lyh
    else
      ly4 = ly4 + 7 + dt
    end
  elseif not paused then
    if ly4 >= 0 - lyh then
      ly4 = ly4 - 7 - dt
    else
      ly4 = 0 - lyh
    end
  end
end

local function idrawQOpt()
  love.graphics.setColor(84,84,84,220)
  love.graphics.rectangle("fill",lx4,ly4,lyw,lyh)
  love.graphics.setColor(255,255,255,255)
  love.graphics.setFont(large)
  love.graphics.print("Quit?",lx4+string.len("quit")*25,ly4)
  love.graphics.setFont(small)
  love.graphics.print("Your progess will not be saved...",lx4+string.len("Your progess will not be saved..."),ly4*1.8)
  love.graphics.setColor(255,255,255,255)
end


local lTimer = 0
local function ilose(dt)
  Animations[1]:pause()
  lTimer = lTimer + dt
  if not booplayed then
    boss.music:stop()
    music:setVolume(0.7)
    music:setPitch(0.5)
    boo:play()
    booplayed = true
  end
  if ly >= screenheight/2 then
    ly = screenheight/2
  else
    ly = ly + 6 + dt
  end
  if lTimer >= 6 then
    music:stop()
    gamestate = "lose"
    ly = 0
    lTimer = 0
  end
end

local function iplayer_die(dt)
  if player.health <= 0 then
    player.dead = true
    ilose(dt)
  end
end


function inf_draw()
  shader_draw(effect)
  current2:setFilter("nearest","nearest")
  love.graphics.draw(current2,current3,0,screenheight-current2:getHeight()- current1:getHeight(),0,1,1)
  current1:setFilter("nearest","nearest")
  love.graphics.draw(current1,0,screenheight-grass:getHeight(),0,1.5,1)
  drawClouds()
  tacoDraw()
  bulletDraw()
  player_draw()
  if player.dead then
    love.graphics.setFont(large)
    love.graphics.setColor(127,0,0)
    love.graphics.print("You have died!",lx-string.len("You have died!")*15,ly)
    love.graphics.setColor(255,255,255,255)
  end
  idrawQOpt()
end

function inf_update(dt)
  iquitOpt(dt)
  if not paused then
    if not player.dead then
      bulletUpdate(dt)
      tacoRain(dt)
      cloudSpawner(dt)
      player_controls(dt)
      player_physics(dt)
    end
    iplayer_die(dt)
  end
end