
function loadGame()
  explosion = idir.."explosion.png"
  framewidth = 64
  frameheight = 64
  S = SpriteSheet.new(explosion,framewidth,frameheight)
  Animations = {}
  a = S:createAnimation()
  for row= 1,4 do
    for col = 1,4 do
      a:addFrame(col,row)
    end
  end
  Animations[#Animations+1]=a
  print("Loading Fonts...")
  small = love.graphics.newFont(fdir2.."orange juice 2.0.ttf",20)
  medium = love.graphics.newFont(fdir2.."orange juice 2.0.ttf",30)
  large = love.graphics.newFont(fdir2.."orange juice 2.0.ttf",60)
  print("Loading Images...")
  iback = love.graphics.newImage(idir.."background1.png")
  grass = love.graphics.newImage(idir.."background.png")
  street = love.graphics.newImage(idir.."street.png")
  glogo = love.graphics.newImage(idir.."logo3.png")
  mount = love.graphics.newImage(idir.."mountains.png")
  mountquad = love.graphics.newQuad(0,0,screenwidth,screenheight,700,309)
  mount:setWrap("repeat","repeat")
  buildin = love.graphics.newImage(idir.."buildings.png")
  buildin:setWrap("repeat","repeat")
  buildquad = love.graphics.newQuad(0,0,screenwidth,screenheight,700,581)
  clouds = love.graphics.newImage(idir.."clouds.png")
  taco = love.graphics.newImage(idir.."taco.png")
  mtaco = love.graphics.newImage(idir.."MegaTaco.png")
  ytaco = love.graphics.newImage(idir.."yuckytaco.png")
  mbut = love.graphics.newImage(idir.."mbutton.png")
  version = love.graphics.newImage(idir.."version.png")
  lvl1 = love.graphics.newImage(idir.."level1.png")
  lvl2 = love.graphics.newImage(idir.."level2.png")
  idk = love.graphics.newImage(idir.."idk.png")
  playera = love.graphics.newImage(idir.."player.png")
  boss1 = love.graphics.newImage(idir.."boss1.png")
  boss2 = love.graphics.newImage(idir.."boss2.png")
  gear = love.graphics.newImage(idir.."gear.png")
  sound = love.graphics.newImage(idir.."musicmute.png")
  mmute = love.graphics.newQuad(0,0,15,30,30,30)
  mplay = love.graphics.newQuad(0,0,30,30,30,30)
  bimg = love.graphics.newImage(idir.."bullet.png")
  missing = love.graphics.newImage(idir.."missing.png")
  bombimg = love.graphics.newImage(idir.."bomb.png")
  print("Loading Sounds...")
  thrift = love.audio.newSource(sdir.."shopmusic.ogg", "static");thrift:setLooping(true)
  music = love.audio.newSource(sdir.."RainingTacos.ogg", "static");music:setLooping(true)
  nom = love.audio.newSource(sdir.."eat.ogg", "static")
  eat = love.audio.newSource(sdir.."nomnom.ogg", "static")
  nope = love.audio.newSource(sdir.."nope.ogg", "static")
  bossnom1 = love.audio.newSource(sdir.."bossnom.ogg", "static")
  bossnom2 = love.audio.newSource(sdir.."bossnom1.wav", "static")
  bosshurt1 = love.audio.newSource(sdir.."ouch.ogg", "static")
  bosshurt2 = love.audio.newSource(sdir.."ouch2.wav", "static")
  bossintro1 = love.audio.newSource(sdir.."saying1.ogg", "static")
  bossintro2 = love.audio.newSource(sdir.."bossintro1.wav", "static")
  bossdie1 = love.audio.newSource(sdir.."saying2.ogg", "static")
  bossdie2 = love.audio.newSource(sdir.."bosslose1.wav", "static")
  bosswin1 = love.audio.newSource(sdir.."say3.ogg", "static")
  bosswin2 = love.audio.newSource(sdir.."bosswin1.wav", "static")
  boom = love.audio.newSource(sdir.."boom.wav", "static")
  bossmusic1 = love.audio.newSource(sdir.."boss.ogg", "static");bossmusic1:setLooping(true)
  bossmusic2 = love.audio.newSource(sdir.."boss2.ogg", "static");bossmusic2:setLooping(true)
  boo = love.audio.newSource(sdir.."boo.ogg", "static")
  yay = love.audio.newSource(sdir.."goal.ogg", "static")
  lel = love.audio.newSource(sdir.."lel.ogg", "static")
  dun = love.audio.newSource(sdir.."dun.ogg", "static")
  lazer = love.audio.newSource(sdir.."lazer.ogg", "static")
  shot = love.audio.newSource(sdir.."shot.ogg", "static")
  loadHats()
end
