
dm = 0
local say = math.random(1,2)

bullet = {}

function bulletSpawn(x,y)
  tc = tc - 0
  bullet.img = bimg
  width = bullet.img:getWidth()
  height = bullet.img:getHeight()
  bangle = 0
  fps = 1550
  local startX = player.x
  local startY = player.y
  local mouseX = love.mouse.getX()
  local mouseY = love.mouse.getY()
  local angle = math.atan2(mouseY - startY,(mouseX - startX))
  local bulletDx = fps * math.cos(angle)
  local bulletDy = fps * math.sin(angle)
  dx = bulletDx
  dy = bulletDy
  table.insert(bullet,{x=startX,y=startY,width=width,height=height,angle=angle,bangle = bangle, fps = fps,id = #bullet + 1,dx=dx,dy=dy})
end

function bulletDraw()
  for _,v in ipairs(bullet) do
    createNewLight(v.x+width/2,v.y+height/2,156/255,41/255,0,100/255)
    love.graphics.draw(bullet.img,v.x,v.y,v.bangle,1,1,width/2,height/2)
  end
end

--[[
 player.x > boss.x and
    player.x < boss.x + boss.width and
    player.y > boss.y and
    player.y < boss.y + boss.height then
]]--

function bulletCollide()
  for _,v in ipairs(bullet) do
    if v.y >= screenheight then
      table.remove(bullet,_)
    end
    if v.y <= 0 then
      table.remove(bullet,_)
    end
    if v.x >= screenwidth then
      table.remove(bullet,_)
    end
    if v.x <= 0 then
      table.remove(bullet,_)
    end
    if CheckCollision(v.x,v.y,v.width,v.height,boss.x,boss.y-boss.height/2,boss.width,boss.height) and bossbattle and bossDetermined and boss.introsaid then
      boss.hurt:play()
      boss.health = boss.health - player.damage
      table.remove(bullet,_)
    end
    for _a,va in ipairs(Taco) do
      if CheckCollision(v.x,v.y,v.width,v.height,va.x,va.y,ytaco:getWidth(),ytaco:getHeight()) and va.ttype == "yucky" and not va.collided  then
        va.collided = true
        table.remove(bullet,_)
        Animations[1]:stop()
        Animations[1]:play()
        boom:stop()
        boom:play()
      end
    end
  end
end

function bulletUpdate(dt)
  for _,v in ipairs(bullet) do
    if not quitclicked then
      bulletCollide()
      v.fps = v.fps
      v.x = v.x + (v.dx * dt)
      v.y = v.y + (v.dy * dt)
      v.bangle = v.angle
    end
  end
end

function bulletShoot(x,y,button)
  bulletSpawn(startX,startY)
end
