   
-- LIGHTING

function createNewLight(x,y,r,g,b,br) -- createNewLight(X Position, Y Position, Red, Green, Blue, Brightness) This can only be called in love.draw()
	local lightW,lightH = plight:getWidth(),plight:getHeight()
	lightxorigin = lightW/2
	lightyorigin = lightH/2
	lightx = (x - lightxorigin)
	lighty = (y - lightyorigin) + 50
	love.graphics.setColor(r,g,b,br)
	love.graphics.draw(plight,lightx,lighty)
  love.graphics.setColor(255,255,255,255)
end

-- Shadow Function INDEV
function createNewShadow(x,y,width,castpos,seg,r,g,b,t)
    love.graphics.setColor(r,g,b,t)
    love.graphics.circle( "fill", x, y, width-castpos/30, seg)
    love.graphics.setColor(255,255,255,255)
end
--
 
 function getMagnitude(x2,x1,y2,y1) -- Gets distance between two vector points
	d = math.sqrt((x2-x1)^2+(y2-y1)^2)
	--print(d)
 end

 function newRay(x1,y1,x2,y2,r,g,b,tr)
	love.graphics.setColor(r,g,b,tr)
	love.graphics.line(x1,y1,x2,y2)
  love.graphics.setColor(255,255,255,255)
 end

 
 
 
 